#COMPILE EXE

FUNCTION PBMAIN () AS LONG
DEFDBL A-Z
GLOBAL T_kelv,KOUNT,mconc,surf_area,gamma,k_CT,k_d,k_a,CO AS DOUBLE
GLOBAL nmax,nvar,KMAX,DXSAV, eps,x1,x2,h1,hmin,nok,nbad AS DOUBLE
GLOBAL htry,hdid,hnext AS DOUBLE

DIM x(100,4)
'choose SOIR orbit data
'OPEN "c:\temp\Venus_clouds.csv" FOR INPUT AS #4
'OPEN "c:\temp\Venus_clouds 671_1.csv" FOR INPUT AS #4
OPEN "c:\temp\Venus_clouds 691_1.csv" FOR INPUT AS #4
'OPEN "c:\temp\Venus_clouds 1581_1.csv" FOR INPUT AS #4
'columns: 1 is z; 2 is T; 3 is CO2; 4 is M
FOR i = 1 TO 200
    IF EOF(4) THEN GOTO 100
    INPUT #4,x(i,1),x(i,2),x(i,3),x(i,4)
NEXT i
100 CLOSE #4
end_z=i
'waitkey$
'read in uptake coefficient and equilibrium constant (for n+1 --> n) as a function of T and number of CO2
DIM g(3900,4)
OPEN "c:\temp\MgCO3_CO2n_co2_v2.txt" FOR INPUT AS #4
'columns: 1 is n_CO2; 2 is temp; 3 is gamma; 4 is keq
FOR i = 1 TO 3900
    IF EOF(4) THEN GOTO 101
    INPUT #4,g(i,1),g(i,2),g(i,3),g(i,4)
NEXT i
101 CLOSE #4
PRINT "Starting ..."
DIM h(100)
DIM w(100)
pi = 3.1415
'vol_tot_part                           total particle volume in a bin
'Kn_air_part                            Knudsen number of particles in air,
'G_slip_part                            Cunningham slip-flow correction, Cunningham, 1910
'Diff_coef_part                         Particle diffusion coefficient in air
'lambda_part                            Particle mean free path
'delta_part                             Particle centres spacing
'rho_part                               Particle density
'vel_therm_part                         Particle thermal velocity

rho_part = 1560  'density of H2O-ice-MSP seed
k_Boltz = 1.3807E-23 'Boltzmann constant, (kg m^2 s^-2 K^-1 molec^-1)
M_air_av=(44)/1e3/6.02e23  'CO2 atmosphere (kg molec^-1)
nu_air = 0.00001792  'dynamic viscosity of air, (kg m^-1 s^-1)
A_dash = 1.249: B_dash = 0.42: C_dash = 0.87 'Kasten (1968) values for the Cunningham slip_flow coeffs.

gamma = 0.01   'uptake coefficient for CO2 on CO2-ice surface
g=8.687  'm s-2
r_1 = 0.35e-9'0.35e-9     'm, initial seed particle radius
radius=r_1
particle_mass = rho_part*4/3*pi*(radius)^3         'kg
particle_mass0 = rho_part*4/3*pi*(radius)^3         'kg
z_step = 0.1                        'km
sumtau=0
del_t=0.1
radius_max=0

GOSUB T_test
OPEN "c:\temp\Venus_ice.txt" FOR OUTPUT AS #7

FOR z = 129 TO 110 STEP -z_step 'for 671.1 or 691.1
'FOR z = 129 TO 80 STEP -z_step  'for 1581.1

    FOR k = 1 TO end_z
        IF x(k,1)<z THEN
            T_kelv=x(k-1,2)+(x(k-1,2)-x(k,2))/(x(k-1,1)-x(k,1))*(z-x(k-1,1))
            co2= x(k-1,3)+(x(k-1,3)-x(k,3))/(x(k-1,1)-x(k,1))*(z-x(k-1,1))
            mconc=x(k-1,4)+(x(k-1,4)-x(k,4))/(x(k-1,1)-x(k,1))*(z-x(k-1,1))
            GOTO 200
        END IF
    NEXT k

200     height=z
        tau_z=0
        del_z=0
        'p(CO2) = 1.38e12*exp(-3182.48/T_Kelv) eqm. vapour pressure in Pa of CO2
        CO2_eq = 1.38e12*EXP(-3182.48/T_Kelv)/k_Boltz/T_Kelv*1e-6  'cm-3
        PRINT "CO2_eq/CO2 in gas phase = ";CO2_eq/(CO2 - n_CO2_total)
        nu_air = 14.8e-6*(293.15+240)/(T_kelv+240)*(T_kelv/293.15)^1.5      'Sutherland formula -for CO2, in Pa s
        rho_air = mconc * ((44)/1e3) / 6.02E+23 * 1000000#                  'air density, (kg m^-3)
'        rho_part = (1.72391 - 2.53e-4*T_kelv + 2.87e-6*T_kelv^2)*1000       'particle density in kg m-3
        vel_air_therm = SQR(8# * k_Boltz * T_kelv / (pi * M_air_av))        'thermal velocity of an air molecule, m s-1
        lambda_air = 2# * nu_air / (rho_air * vel_air_therm)                'mean free path of an air molecule
        Kn_air_part = lambda_air / radius                                   'Knudsen number of particles in air
        G_slip_part = 1 + Kn_air_part * (A_dash + B_dash * EXP(-C_dash / Kn_air_part))  'Cunningham slip-flow correction, Cunningham, 1910, approximation after Knudsen & Weber, 1911
247     radius=5e-9:w2 = -((2 * g * radius ^ 2) * (rho_part - rho_air) * G_slip_part) /(9 * nu_air) 'sedimentation rate (Stokes' Equation): in m s-1
        w2=-w2/1e3  'in km s-1
        w2=-100*w2    'in cm s-1
        PRINT
        PRINT radius,z,w2:SLEEP 2000
        PRINT
        tau = z_step*1e5/w2    's, time to fall z_step km
        IF tau>2e4 THEN GOTO 300

        FOR t = 0 TO 1 STEP del_t
            n_CO2 = INT(particle_mass/(0.044/6.02e23)+0.5)
'            if T_kelv > 120 then n_CO2=4:particle_mass=particle_mass0
            IF n_CO2 < 4 THEN
                n_CO2=3
                particle_mass=particle_mass0 'kg
                particle_vol = particle_mass/rho_part   'm3, new particle volume
                radius = (3/4/pi*particle_vol)^(1/3)    'in m
            END IF
            IF n_CO2 > 40 THEN
                gamma=0.1
                keq = (1.38e12 * EXP(-3182.48 / T_kelv) / 1.38E-23 / T_kelv * 0.000001)
                GOTO 36
            END IF
            IF n_CO2 <= 40 THEN
                FOR i = 3838 TO 101 STEP -1
                    IF n_CO2 = g(i,1) THEN
                        FOR j = i TO i-100 STEP -1
                            IF T_kelv > g(j,2) THEN gamma=g(j,3):keq = g(j,4):GOTO 36
                        NEXT j
                    END IF
                NEXT i
            END IF
            PRINT "Bad" :PRINT radius*1e9:GOTO 400
            36 gamma=gamma*mconc/(3.2E+16 * 10^-5 * 300 / T_kelv)   'the data in MgCO3_CO2n_CO2.txt was calculated at 1e-5 Torr in MgCO3_nCO2.bas
            IF gamma>0.1 THEN gamma=0.1             'set an upper limit
            surface_area = 4*pi*(100*radius)^2    'cm2
            uptake_rate = 0.25*gamma*(vel_air_therm*100)*surface_area 'cm3 s-1
            evaporation_rate = uptake_rate*keq  's-1
          '  print "Evaporation rate = ";evaporation_rate
            CO2_uptake = (uptake_rate*(CO2 - n_CO2_total )- evaporation_rate)*del_t   'number of molecules taken up in del_t seconds; CO2 = total gas-phase CO2, n_CO2_total = total CO2 in particles; CO2_eq = equilibrium concentration over solid CO2
                                                                                      'evaporation occurs if CO2_eq > CO2 - n_CO2_total
            CO2_uptake_mass = CO2_uptake*0.044/6.02e23  'kg of new CO2-ice
            particle_mass = particle_mass + CO2_uptake_mass    'kg, new particle mass
'            if T_kelv > 110 then particle_mass=particle_mass0
            IF particle_mass < particle_mass0 THEN particle_mass = particle_mass0
            particle_vol = particle_mass/rho_part   'm3, new particle volume
            radius = (3/4/pi*particle_vol)^(1/3)    'in m
            n_CO2 = INT(particle_mass/(0.044/6.02e23)+0.5)
            del_z = del_z + w2*del_t
            IF radius > 0.5e-9 THEN sumtau=sumtau+del_t:tau_z=tau_z+del_t
            IF del_z > z_step*1e5 THEN GOTO 300
        NEXT t
        GOTO 247
300     PRINT "Height = ";INT(100*z)/100;" km","Tau = ";INT(tau*10)/10;" s","Radius = ";INT(1e11*radius)/100;" nm";"  gamma = ";INT(1000000*gamma)/1000000;" T = ";INT(10*T_kelv)/10
        PRINT "n_CO2 ="; n_CO2
        PRINT "i = ";i;"  j = ";j
        PRINT "uptake rate = ";CO2_uptake
        IF radius>radius_max THEN radius_max=radius:height_max=z
        n_CO2_total = 100*n_CO2 'assuming 100 cm-3 particles in the cloud
        PRINT "Fraction of CO2 condensed = ";n_CO2_total/CO2
        PRINT
        PRINT #7,z,tau_z,sumtau,radius*1e9
NEXT z
400 PRINT "Time to fall while visible (r > 100 nm)= ";sumtau/60;" minutes"
PRINT "Maximum radius = ";INT(1e11*radius_max)/100;" nm at ";INT(10*height_max)/10;" km"
WHILE NOT INSTAT
WEND
t_test:
OPEN "c:\temp\CO2 ice nucleation.txt" FOR OUTPUT AS #7
radius=0.35e-9   'm
surface_area = 4*pi*(100*radius)^2    'cm2
particle_mass = rho_part*4/3*pi*(radius)^3

FOR T_kelv = 145 TO 50 STEP -1
    n_co2=3
    radius=0.35e-9   'm
    surface_area = 4*pi*(100*radius)^2    'cm2
    particle_mass = rho_part*4/3*pi*(radius)^3
    FOR t = 0 TO 1 STEP del_t
                FOR i = 3838 TO 101 STEP -1
                    IF n_CO2 = g(i,1) THEN
                        FOR j = i TO i-100 STEP -1
                            IF T_kelv > g(j,2) THEN gamma=g(j,3):keq = g(j,4):GOTO 39
                        NEXT j
                    END IF
                NEXT i

39         vel_air_therm = SQR(8# * k_Boltz * T_kelv / (pi * M_air_av))
            CO2=2.51e-3/1.38e-23/T_kelv/1e6 'cm-3
            gamma=gamma*CO2/(3.2E+16 * 10^-5 * 300 / T_kelv)   'the data in MgCO3_CO2n_CO2.txt was calculated at 1e-5 Torr in MgCO3_nCO2.bas
            IF gamma>0.1 THEN gamma=0.1
            surface_area = 4*pi*(100*radius)^2    'cm2
            uptake_rate = 0.25*gamma*(vel_air_therm*100)*surface_area 'cm3 s-1
            evaporation_rate = uptake_rate*keq  's-1
'           CO2_uptake = (uptake_rate*(CO2)- evaporation_rate)'number of CO2 molecules per second
            CO2_uptake = (uptake_rate*(CO2)- evaporation_rate)*del_t   'number of molecules taken up in del_t seconds; CO2 = total gas-phase CO2, n_CO2_total = total CO2 in particles; CO2_eq = equilibrium concentration over solid CO2
            IF CO2_uptake<=0 THEN GOTO 234
           'evaporation occurs if CO2_eq > CO2 - n_CO2_total
            CO2_uptake_mass = CO2_uptake*0.044/6.02e23  'kg of new CO2-ice
            particle_mass = particle_mass + CO2_uptake_mass    'kg, new particle mass
'            if T_kelv > 110 then particle_mass=particle_mass0
            IF particle_mass < particle_mass0 THEN particle_mass = particle_mass0
            particle_vol = particle_mass/rho_part   'm3, new particle volume
            radius = (3/4/pi*particle_vol)^(1/3)    'in m
            n_CO2 = particle_mass/(0.044/6.02e23) 'INT(particle_mass/(0.044/6.02e23)+0.5)
    NEXT t
            PRINT T_kelv,n_CO2,radius
            PRINT #7,T_kelv,n_CO2
234 NEXT T_kelv
CLOSE #7
WAITKEY$
RETURN
END FUNCTION
